// $Id: BarGraph.h,v 1.9 2001/03/28 02:29:42 rob Exp $

#ifndef BARGRAPH_H
#define BARGRAPH_H

#include "TimedContainer.h"

typedef struct {
    int cur;	// if cur<min, no bar drawn; cur>max means bar fills window
    short last_x;
    short y;
    short h;
} BarInfo;

#define COLOR_SCHEME_CUSTOM	0
#define COLOR_SCHEME_RYG	1
#define COLOR_SCHEME_GREEN	2
#define COLOR_SCHEME_GYR	3

typedef struct _BarColor {
    int breakpoint;
    XColor color;
    string *colorName;
    GC gc;
    struct _BarColor *next;
} BarColor;

class BarGraph: public TimedContainer {
  protected:
    int min;
    int max;
    int range;	// shorthand for max-min;
    string label;
	
    BarInfo bar;

    short colorScheme;
    BarColor *colorList;
	
  public:
    BarGraph(Container *parent, int tc);
    BarGraph(Container *parent, int tc, int min, int max, char *label);
    BarGraph(Container *parent, int tc, int min, int max, char *label, int scheme);
    void setScheme(int scheme);
    void realize();
    void setPreferredSize(int dir);
    virtual void setRange(int min, int max);
    void setLabel(char *label);
    void prepare();
    void paint();
    void update();

  protected:
    void drawBar(BarInfo *b);
    void addColor(int breakpoint, char *colorName);
    void allocScheme();
    void allocColors();
};

#endif // CONTAINER_H
