// $Id: Chart.h,v 1.4 2001/03/03 22:02:34 rob Exp $

#ifndef CHART_H
#define CHART_H

#include "TimedContainer.h"

#define SEGMENTS_PER_DRAW 16
#define MAX_ZOOM 4

class Chart: public TimedContainer {
  protected:
    int valuePerZoom; // height of one screen

    string chartColorName;
    string zoomColorName;
    GC chartGC,zoomGC;

    int store; // starting position of circular buffer
    int *buffer;
	
  public:
    Chart(Container *parent, int tc);
    Chart(Container *parent, int tc, int max);
    void realize();
    void setPreferredSize(int dir);
    virtual void setValue(int value);
    void prepare();
    void paint();
    void update();

  protected:
    int getZoom();
    void drawChart();
    void allocChart();
};

#endif // CONTAINER_H
