// $Id: Clock.cc,v 1.5 2001/03/03 22:02:34 rob Exp $

#include "Clock.h"

Clock::Clock(Container *parent, int tc): TimedContainer(parent,tc) {
  dprintf("in Clock::Clock\n");
}

Clock::Clock(Container *parent, int tc, int hoffset, int moffset): TimedContainer(parent,tc) {
  dprintf("in Clock::Clock\n");

  hourOffset=hoffset;
  minuteOffset=moffset;
}

void Clock::setOffset(int hoffset, int moffset) {
  hourOffset=hoffset;
  minuteOffset=moffset;
}
	

// Overriding Container::paint to draw a clock face
void Clock::prepare() {
  dprintf("in Clock::prepare\n");

  time_t t=time(NULL);
  struct tm *tmval=localtime(&t);

  hour = ((int) tmval->tm_hour + hourOffset) % 12;
  minute = ((int) tmval->tm_min + minuteOffset) % 60;
}
