// $Id: CutBuffer.h,v 1.6 2001/03/03 22:02:34 rob Exp $

#ifndef CUTBUFFER_H
#define CUTBUFFER_H

#include "TextBox.h"

class CutBuffer: public TextBox {
  protected:
    static int buffer_count; // count of cutbuffers; used to create atom_name
    static CutBuffer *selected; // pointer to currently highlighted cutbuffer
    static CutBuffer *first; // pointer to first cutbuffer
	
    int buffer_number;
    Atom atom;
    char atom_name[16];
    CutBuffer *next; // pointer to currently highlighted cutbuffer
	
	
  public:
    CutBuffer(Container *parent, int rows);
    static void create(Container *parent, int rows);
    void setHighlight(bool highlight); // also sets/unsets selected
    void handleButtonPress(XButtonEvent *e);
    static CutBuffer *getCurrentCutBuffer();
    static void doPropertyNotify(XPropertyEvent *e);
    void handlePropertyNotify(XPropertyEvent *e);
    void handleSelectionRequest(XSelectionRequestEvent *e);
    void handleSelectionClear(XSelectionClearEvent *e);

  private:
    void allocAtom();
    void getBuffer();
    void setAsPrimaryBuffer(XButtonEvent *e);
    void pasteIntoBuffer();
};

#endif // CONTAINER_H
