// $Id: DualBarGraph.cc,v 1.2 2001/03/03 22:02:34 rob Exp $

#include "DualBarGraph.h"

DualBarGraph::DualBarGraph(Container *parent, int tc): BarGraph(parent,tc) {
  dprintf("\nin DualBarGraph::DualBarGraph\n");
}

DualBarGraph::DualBarGraph(Container *parent, int tc, int min, int max, char *label): BarGraph(parent,tc,min,max,label) {
  dprintf("\nin DualBarGraph::DualBarGraph\n");

  setRange(min,max);
}

void DualBarGraph::setPreferredSize(int dir) {
  dprintf("in DualBarGraph::setPreferredSize\n");

  BarGraph::setPreferredSize(dir);

  int halfH=(h-2*BORDER_WIDTH)/2;
  bar.y=BORDER_WIDTH;
  bar.h=halfH;
  bar2.y=bar.y+bar.h;
  bar2.h=halfH;
}

void DualBarGraph::setRange(int min, int max) {
  dprintf("in DualBarGraph::setRange\n");

  BarGraph::setRange(min,max);
	
  bar2.cur=min-1; // guarantee that no bar is drawn to start
  bar2.last_x=0; // force redraw of entire bar at next update
}

void DualBarGraph::prepare() {
  dprintf("in DualBarGraph::prepare\n");

  bar.cur=((bar.cur+7)*3)%range;
  bar2.cur=((bar2.cur+3)*7)%range;
}

void DualBarGraph::paint() {
  dprintf("in DualBarGraph::paint\n");
	
  bar.last_x=0;
  drawBar(&bar);
  bar2.last_x=0;
  drawBar(&bar2);
}

void DualBarGraph::update() {
  dprintf("in DualBarGraph::update\n");
	
  drawBar(&bar);
  drawBar(&bar2);
}
