// $Id: LoadAvg.cc,v 1.3 2001/03/03 22:02:34 rob Exp $

#include "LoadAvg.h"

LoadAvg::LoadAvg(Container *parent, int tc): Chart(parent,tc) {
  dprintf("in LoadAvg::LoadAvg\n");
}

void LoadAvg::prepare() {
  dprintf("in LoadAvg::prepare\n");

  setValue(getCurrentLoad());
}

// Linux code to get one minute load average.
int LoadAvg::getCurrentLoad() {
  char buf[128];
	
  int fd = open("/proc/loadavg", O_RDONLY);
  if (fd>0) {
    ssize_t len=read(fd,buf,sizeof(buf)-1);
    buf[len]=(char)0;
    close(fd);

    float one,five,fifteen;
    sscanf(buf,"%f %f %f",&one,&five,&fifteen);

    return (int)(100*one);
  }
  return 0;
}
