// $Id: Manager.h,v 1.9 2001/03/03 22:02:34 rob Exp $

#ifndef MANAGER_H
#define MANAGER_H

#include "Container.h"

typedef void (*propertyNotifyCallback_t)(XPropertyEvent *);

class Manager: public Container {
    static propertyNotifyCallback_t propertyNotifyCallback;

  protected:
    XSizeHints *sizehints;
    int x_req;
    int y_req;
    unsigned int width_req;
    unsigned int height_req;
    int geometry_flags;
	
  public:
    Manager(char *geometry, int argc, char **argv, char *app_name, char *app_class);
    Manager(int w, int h, char *geometry, int argc, char **argv, char *app_name, char *app_class);
    Manager(int x, int y, int w, int h, char *geometry, int argc, char **argv, char *app_name, char *app_class);
    virtual void invalidate();
    virtual void doLayout();
    virtual void setLayout(Container *target);
    void realize();
    void resize();
    virtual void setPreferredSize();
    virtual void paintAll();
	
    static void registerPropertyNotifyHandler(propertyNotifyCallback_t);
    static void firePropertyNotifyHandler(XPropertyEvent *e);
    static void processEvent(XEvent *e);
    static void eventLoop();

  private:
    void _init(char *geometry, int argc, char **argv, char *app_name, char *app_class);
};

#endif // MANAGER_H
