// $Id: Memory.cc,v 1.5 2001/03/03 22:02:34 rob Exp $

#include "Memory.h"

Memory::Memory(Container *parent, int tc): BarGraph(parent,tc) {
  dprintf("in Memory::Memory\n");

  setRange(0,100);
  setLabel("Memory");
}

void Memory::prepare() {
  dprintf("in Memory::prepare\n");

  bar.cur=getPercentUsed();
}

// get percentage (0-100) of memory used by applications
int Memory::getPercentUsed() {
  int perc=0;
  char buf[1024];
	
  int fd = open("/proc/meminfo", O_RDONLY);
  if (fd>0) {
    ssize_t len=read(fd,buf,sizeof(buf)-1);
    buf[len]=(char)0;
    close(fd);

    char *str=strstr(buf,"Mem:");

      /* Occasionally, the read seems to return the wrong thing, or at least
         it returns something after the Memory: entry.  Perhaps the lseek isn't
         resetting to 0 and we have some interaction between the get_memory
         read, but for whatever reason, we need to check that str is valid
      */
    if (str) {
      long total, used, unused, shared, buffers, cached;
			
      sscanf(str,"Mem: %ld %ld %ld %ld %ld %ld",
        &total,&used,&unused,&shared,&buffers,&cached);
			
      perc=(int)((used-buffers-cached)/(total/100));
			
      dprintf("total=%ld used=%ld unused=%ld shared=%ld buffers=%ld cached=%ld\n",
        total,used,unused,shared,buffers,cached);
    }
  }
  return perc;
}
