// $Id: RowManager.cc,v 1.5 2001/03/03 22:02:34 rob Exp $

/*
  This is a subclass of Container for main application windows only.
*/

#include "RowManager.h"



RowManager::RowManager(char *geometry, int argc, char **argv, char *app_name, char *app_class): TimeManager(geometry,argc,argv,app_name,app_class) {
  dprintf("in RowManager::RowManager\n");

  direction=Container::VERTICAL;
  if (width_req<MIN_BASE_DIMENSION) this->base=MIN_BASE_DIMENSION;
  else this->base=width_req;
  invalidate();
}


int RowManager::getBase() 
{
  return base;
}

void RowManager::invalidate() 
{
  nextPosition=-(BORDER_WIDTH);
}

// Apparently, because this is called in a constructor, the virtual functions
// don't work.  setLayout is called way down in Container::Container, so because
// it is only a Container object at that point, virtual functions don't matter.
// It looks like I'll have to implement some sort of resize thing and
// recalculate the sizes and positions.
void RowManager::setLayout(Container *target) 
{
  if (direction == VERTICAL) {
    target->x=-(BORDER_WIDTH);
    target->y=nextPosition;
    target->w=base; // guess the size
    target->h=base;
    target->setPreferredSize(VERTICAL); // let the Container resize itself
    nextPosition+=target->h+BORDER_WIDTH;
  }
  else {
    target->x=-(BORDER_WIDTH);
    target->y=nextPosition;
    target->w=base;
    target->h=base;
    target->setPreferredSize(HORIZONTAL);
    nextPosition+=target->w+BORDER_WIDTH;
  }
}

void RowManager::setPreferredSize() 
{
  if (direction == VERTICAL) {
    w=base;
    h=nextPosition;
  }
  else {
    w=nextPosition;
    h=base;
  }
}
