// $Id: Swap.cc,v 1.6 2001/03/03 22:02:34 rob Exp $

#include "Swap.h"

Swap::Swap(Container *parent, int tc): BarGraph(parent,tc) {
  dprintf("in Swap::Swap\n");

  setRange(0,100);
  setLabel("Swap");
  setScheme(COLOR_SCHEME_GYR);
}

void Swap::prepare() {
  dprintf("in Swap::prepare\n");

  bar.cur=getPercentUsed();
}

// return integer percentage (0-100) of swap space used.
int Swap::getPercentUsed() {
  int perc=0;
  char buf[256];
	
  int fd = open("/proc/meminfo", O_RDONLY);
  if (fd>0) {
    ssize_t len=read(fd,buf,sizeof(buf)-1);
    buf[len]=(char)0;
    close(fd);

    char *str=strstr(buf,"Swap:");

      /* Occasionally, the read seems to return the wrong thing, or at least
         it returns something after the Swap: entry.  Perhaps the lseek isn't
         resetting to 0 and we have some interaction between the get_memory
         read, but for whatever reason, we need to check that str is valid
      */
    if (str) {
      long total, used, unused;
			
      sscanf(str,"Swap: %ld %ld %ld",
        &total,&used,&unused);
			
      perc=(int)(used/(total/100));
			
      dprintf("total=%ld used=%ld unused=%ld  perc=%d\n",
        total,used,unused,perc);
    }
  }
  return perc;
}
	
