// $Id: Temperature.cc,v 1.1 2001/03/28 02:30:03 rob Exp $

#include "Temperature.h"

Temperature::Temperature(Container *parent, int tc, char *filename, int min, int max, char *label): BarGraph(parent,tc,min,max,label,COLOR_SCHEME_GYR) {
  dprintf("in Temperature::Temperature\n");

  this->filename=filename;
}

void Temperature::prepare() {
  dprintf("in Temperature::prepare\n");

  bar.cur=getTemperature();
}

// return integer temperature in degrees celsius.
int Temperature::getTemperature() {
  int temp=0;
  char buf[256];
	
  int fd = open(filename.c_str(), O_RDONLY);
  if (fd>0) {
    ssize_t len=read(fd,buf,sizeof(buf)-1);
    buf[len]=(char)0;
    close(fd);

    float hysteresis, limit, value;
    sscanf(buf,"%f %f %f",&hysteresis, &limit, &value);
    
    temp=(int)value;
    
    dprintf("temp=%d\n",temp);
  }
  return temp;
}
	
