// $Id: TimeManager.h,v 1.7 2001/04/28 17:51:31 rob Exp $

#ifndef TIMEMANAGER_H
#define TIMEMANAGER_H

#include "Manager.h"
#include "TimedContainer.h"

#include <sys/time.h>
#include <sys/types.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>

class TimeManager: public Manager {
    static int tickHappened;
    static int secondsPerTick;

    static int readPipe;
    static int writePipe;

  public:
    TimeManager(char *geometry, int argc, char **argv, char *app_name, char *app_class);

      /** Loop through all of the Container objects of this Manager
       * and redraw everything.  No optimization is currently done in
       * the drawing, the windows are simply cleared and painted with
       * their new contents.
       */
    void incrementAll();
    
      /** Start the main loop.  This loop never returns, in the event
       * of a catastrophic error, exit() is called.
       * @seconds number of seconds between "ticks"; i.e. how long to
       * wait before going through every Container to update the
       * status.
       */
    void eventLoop(int seconds);

  private:
    static void sighandler(int sig);
};

#endif // ALIGNEDCONTAINER_H
