// $Id: TimedContainer.h,v 1.4 2001/03/03 22:02:34 rob Exp $

#ifndef TIMEDCONTAINER_H
#define TIMEDCONTAINER_H

#include "Container.h"

class TimedContainer: public Container {
    short tick;
    short tickCount;
	
  public:
    TimedContainer(Container *parent, int tc);

    void realize();
    void setPreferredSize(int dir);
    int getTick();
    int getTickCount();
    bool incrementTick(); // inc tick and return true if the tick count has been reached
    bool setTick(int tick); // return true if tick count is reached and tick is reset to zero
    bool setTickCount(int tc); // return true if tick count would have been reached because tick count is lowered below tick

    virtual void prepare(); // prepare before painting
    void paint();
    virtual void update(); // virtual method to call if the tick causes a graphical change

  private:
    void _init(int tc);
};

#endif // CONTAINER_H
