// $Id: Today.cc,v 1.4 2001/03/03 22:02:34 rob Exp $

#include "Today.h"

Today::Today(Container *parent, int tc): TimedContainer(parent,tc) {
  dprintf("in Today::Today\n");

  this->format="%a %d %b";
}

Today::Today(Container *parent, int tc, char *format): TimedContainer(parent,tc) {
  dprintf("in Today::Today\n");

  this->format=format;
}

void Today::setPreferredSize(int dir) {
  dprintf("in Today::setPreferredSize\n");
	
  if (dir==VERTICAL) {
    h=font_height+BORDER_WIDTH;
  }
  else {
    w=h;
  }
}

void Today::drawText() {
  dprintf("in Today::drawText\n");
	
  char str[32];
	
  time_t t = time(NULL);
  struct tm *tmval = localtime(&t);
  size_t count=strftime(str,32,format.c_str(),tmval);

  int y = BORDER_WIDTH + font_ascent;
  drawCenteredText(drawGC,w/2,y,str,count);
}

void Today::paint() {
  dprintf("in Today::paint\n");
	
  drawText();
}

